function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PureComponent } from 'react';
import 'core-js/modules/es6.object.keys';
import { immutableRegionsFromAnnotations } from '@annotation-studio/bridge/es/annotations';
import { richAnnotationList } from '@annotation-studio/redux/es/query/elucidateQuery';
import { currentCanvas } from '@annotation-studio/redux/es/query/manifestQuery';
import { resourceTemplateList } from '@annotation-studio/redux/es/query/resourceQuery';
import { Canvas } from '@annotation-studio/components';
import { connector } from '@annotation-studio/redux';
import { selectorCompat } from '@annotation-studio/redux/es/utility';
import Measure from 'react-measure';
import { withState } from 'recompose';

var Viewer = function (_PureComponent) {
  _inherits(Viewer, _PureComponent);

  function Viewer() {
    _classCallCheck(this, Viewer);

    return _possibleConstructorReturn(this, _PureComponent.apply(this, arguments));
  }

  Viewer.prototype.setViewer = function setViewer(viewer) {
    if (this.viewer) {
      return;
    }
    this.viewer = viewer;
    this.props.setViewer(viewer);
  };

  Viewer.prototype.render = function render() {
    var _this2 = this;

    var MAX_HEIGHT = window.innerHeight * 0.8;

    var _props = this.props,
        image = _props.image,
        selectedViewer = _props.selectedViewer,
        updateDimensions = _props.updateDimensions,
        editableRegions = _props.editableRegions,
        dimensions = _props.dimensions,
        state = _props.state,
        toggleable = _props.toggleable,
        drafts = _props.drafts,
        currentDraftSelectors = _props.currentDraftSelectors,
        updateSelector = _props.updateSelector,
        editCurrentDraftSecondarySelector = _props.editCurrentDraftSecondarySelector,
        commitToCurrentDraft = _props.commitToCurrentDraft,
        editCurrentDraftSelector = _props.editCurrentDraftSelector,
        currentSelector = _props.currentSelector,
        showControls = _props.showControls,
        showAnnotations = _props.showAnnotations;

    var VIEWER_WIDTH = dimensions.width;

    var regions = [].concat(editableRegions, immutableRegionsFromAnnotations(richAnnotationList(state), resourceTemplateList(state)), currentDraftSelectors).map(function (region) {
      return selectorCompat(region);
    });

    // @todo move to selector
    var selectedCanvas = currentCanvas(state);
    return React.createElement(
      Measure,
      { onMeasure: function onMeasure(newDimensions) {
          return updateDimensions(newDimensions);
        } },
      React.createElement(
        'div',
        { style: { height: '100%' } },
        selectedCanvas ? React.createElement(Canvas, {
          ref: function ref(_ref) {
            return _this2.setViewer(_ref);
          },
          showAnnotations: showAnnotations,
          showAnnotationToggle: toggleable === 'true',
          onUpdateSelector: updateSelector,
          showControls: showControls,
          onSaveSelector: commitToCurrentDraft,
          selector: currentSelector && currentSelector.type ? currentSelector : null,
          selectedViewer: selectedViewer,
          image: image,
          canvas: selectedCanvas,
          regions: regions,
          displayWidth: VIEWER_WIDTH,
          onEditRegion: function onEditRegion(e) {
            if (e.isSecondary) {
              if (!e.id) {
                return;
              }
              editCurrentDraftSecondarySelector(e.id);
            }
            editCurrentDraftSelector();
          },
          maxHeight: MAX_HEIGHT
        }) : React.createElement(
          'div',
          { style: { height: '80vh', textAlign: 'center' } },
          React.createElement('img', {
            src: image.src,
            style: { maxHeight: '100%', margin: '0 auto' }
          })
        )
      )
    );
  };

  return Viewer;
}(PureComponent);

export default connector(withState('dimensions', 'updateDimensions', { width: -1, height: -1 })(
/*onlyUpdateForKeys([
 'image',
 'selectedViewer',
 'drafts',
 'currentDraft',
 'updateSelector',
 'commitToCurrentDraft',
 'currentSelector',
 ])(*/Viewer /*)*/
));