function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import { render } from 'react-dom';
import { utils } from '@annotation-studio/plugin-core';
import ViewerProvider from './viewer.provider';

export default function ViewerPlugin($el, _ref, store) {
  var viewer = _ref.viewer,
      height = _ref.height,
      width = _ref.width,
      imageSrc = _ref.imageSrc,
      toggleable = _ref.toggleable,
      showControls = _ref.showControls,
      showAnnotations = _ref.showAnnotations,
      unknownProps = _objectWithoutProperties(_ref, ['viewer', 'height', 'width', 'imageSrc', 'toggleable', 'showControls', 'showAnnotations']);

  utils.unknownPropertyWarning(unknownProps);

  var image = {
    src: imageSrc || $el.querySelector('img').src,
    height: parseInt(height, 10) || 0,
    width: parseInt(width, 10) || 0
  };

  var showAnno = function showAnno() {
    if (showAnnotations === 'false') {
      return false;
    } else if (showAnnotations === 'true' || !showAnnotations) {
      return true;
    }
  };

  render(React.createElement(ViewerProvider, {
    toggleable: toggleable,
    showControls: showControls,
    selectedViewer: viewer,
    image: image,
    store: store,
    showAnnotations: showAnno()
  }), $el);
}