'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

require('core-js/modules/es6.object.keys');

var _annotations = require('@annotation-studio/bridge/es/annotations');

var _elucidateQuery = require('@annotation-studio/redux/es/query/elucidateQuery');

var _manifestQuery = require('@annotation-studio/redux/es/query/manifestQuery');

var _resourceQuery = require('@annotation-studio/redux/es/query/resourceQuery');

var _components = require('@annotation-studio/components');

var _redux = require('@annotation-studio/redux');

var _utility = require('@annotation-studio/redux/es/utility');

var _reactMeasure = require('react-measure');

var _reactMeasure2 = _interopRequireDefault(_reactMeasure);

var _recompose = require('recompose');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Viewer = function (_PureComponent) {
  _inherits(Viewer, _PureComponent);

  function Viewer() {
    _classCallCheck(this, Viewer);

    return _possibleConstructorReturn(this, _PureComponent.apply(this, arguments));
  }

  Viewer.prototype.setViewer = function setViewer(viewer) {
    if (this.viewer) {
      return;
    }
    this.viewer = viewer;
    this.props.setViewer(viewer);
  };

  Viewer.prototype.render = function render() {
    var _this2 = this;

    var MAX_HEIGHT = window.innerHeight * 0.8;

    var _props = this.props,
        image = _props.image,
        selectedViewer = _props.selectedViewer,
        updateDimensions = _props.updateDimensions,
        editableRegions = _props.editableRegions,
        dimensions = _props.dimensions,
        state = _props.state,
        toggleable = _props.toggleable,
        drafts = _props.drafts,
        currentDraftSelectors = _props.currentDraftSelectors,
        updateSelector = _props.updateSelector,
        editCurrentDraftSecondarySelector = _props.editCurrentDraftSecondarySelector,
        commitToCurrentDraft = _props.commitToCurrentDraft,
        editCurrentDraftSelector = _props.editCurrentDraftSelector,
        currentSelector = _props.currentSelector,
        showControls = _props.showControls,
        showAnnotations = _props.showAnnotations;

    var VIEWER_WIDTH = dimensions.width;

    var regions = [].concat(editableRegions, (0, _annotations.immutableRegionsFromAnnotations)((0, _elucidateQuery.richAnnotationList)(state), (0, _resourceQuery.resourceTemplateList)(state)), currentDraftSelectors).map(function (region) {
      return (0, _utility.selectorCompat)(region);
    });

    // @todo move to selector
    var selectedCanvas = (0, _manifestQuery.currentCanvas)(state);
    return _react2.default.createElement(
      _reactMeasure2.default,
      { onMeasure: function onMeasure(newDimensions) {
          return updateDimensions(newDimensions);
        } },
      _react2.default.createElement(
        'div',
        { style: { height: '100%' } },
        selectedCanvas ? _react2.default.createElement(_components.Canvas, {
          ref: function ref(_ref) {
            return _this2.setViewer(_ref);
          },
          showAnnotations: showAnnotations,
          showAnnotationToggle: toggleable === 'true',
          onUpdateSelector: updateSelector,
          showControls: showControls,
          onSaveSelector: commitToCurrentDraft,
          selector: currentSelector && currentSelector.type ? currentSelector : null,
          selectedViewer: selectedViewer,
          image: image,
          canvas: selectedCanvas,
          regions: regions,
          displayWidth: VIEWER_WIDTH,
          onEditRegion: function onEditRegion(e) {
            if (e.isSecondary) {
              if (!e.id) {
                return;
              }
              editCurrentDraftSecondarySelector(e.id);
            }
            editCurrentDraftSelector();
          },
          maxHeight: MAX_HEIGHT
        }) : _react2.default.createElement(
          'div',
          { style: { height: '80vh', textAlign: 'center' } },
          _react2.default.createElement('img', {
            src: image.src,
            style: { maxHeight: '100%', margin: '0 auto' }
          })
        )
      )
    );
  };

  return Viewer;
}(_react.PureComponent);

exports.default = (0, _redux.connector)((0, _recompose.withState)('dimensions', 'updateDimensions', { width: -1, height: -1 })(
/*onlyUpdateForKeys([
 'image',
 'selectedViewer',
 'drafts',
 'currentDraft',
 'updateSelector',
 'commitToCurrentDraft',
 'currentSelector',
 ])(*/Viewer /*)*/
));
module.exports = exports['default'];