'use strict';

exports.__esModule = true;
exports.default = ViewerPlugin;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _pluginCore = require('@annotation-studio/plugin-core');

var _viewer = require('./viewer.provider');

var _viewer2 = _interopRequireDefault(_viewer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function ViewerPlugin($el, _ref, store) {
  var viewer = _ref.viewer,
      height = _ref.height,
      width = _ref.width,
      imageSrc = _ref.imageSrc,
      toggleable = _ref.toggleable,
      showControls = _ref.showControls,
      showAnnotations = _ref.showAnnotations,
      unknownProps = _objectWithoutProperties(_ref, ['viewer', 'height', 'width', 'imageSrc', 'toggleable', 'showControls', 'showAnnotations']);

  _pluginCore.utils.unknownPropertyWarning(unknownProps);

  var image = {
    src: imageSrc || $el.querySelector('img').src,
    height: parseInt(height, 10) || 0,
    width: parseInt(width, 10) || 0
  };

  var showAnno = function showAnno() {
    if (showAnnotations === 'false') {
      return false;
    } else if (showAnnotations === 'true' || !showAnnotations) {
      return true;
    }
  };

  (0, _reactDom.render)(_react2.default.createElement(_viewer2.default, {
    toggleable: toggleable,
    showControls: showControls,
    selectedViewer: viewer,
    image: image,
    store: store,
    showAnnotations: showAnno()
  }), $el);
}
module.exports = exports['default'];